import getopt, math, random, sys, time, types, wx, subprocess, os
import threading
import os.path
import time
from multiprocessing import Process, Queue, cpu_count, current_process, freeze_support
from Queue import Empty

import shutil

import wx.lib.agw.multidirdialog as MDD
 

class LeftPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)
        
        self.panel = wx.Panel(self, wx.ID_ANY)
        self.currentDirectory = os.getcwd()
        

        self.chooseGnBox = wx.SingleChoiceDialog(None, 'Select the gene option', 'Gene Options', ['All','wzi','wza','wzb','wzc','wzx','wzy','wbap','wcaj'])
        
        if self.chooseGnBox.ShowModal() == wx.ID_OK:
            gnnm = self.chooseGnBox.GetStringSelection()
        
        self.chooseOneBox = wx.SingleChoiceDialog(None, 'Select the alignment option', 'Alignment Options', ['NN','PP','NP'])
        
        if self.chooseOneBox.ShowModal() == wx.ID_OK:
            algnmnt = self.chooseOneBox.GetStringSelection()

                
        self.openFileDlgBtn = wx.Button(self, -1, 'Select input Files')
        self.Bind(wx.EVT_BUTTON, self.OpenFl, self.openFileDlgBtn)
        
                        
        # Set some program flags
        self.keepgoing = True
        self.i = 0
        self.j = 0
        
        self.my_text = wx.TextCtrl(self, style=wx.TE_MULTILINE)
        self.btn = wx.Button(self, -1, 'K-type Prediction')
        self.Bind(wx.EVT_BUTTON, self.onOpen, self.btn)
        self.obtn = wx.Button(self, -1, 'O-type Prediction')
        self.Bind(wx.EVT_BUTTON, self.onOOpen, self.obtn)
        self.vbtn = wx.Button(self, -1, 'Virulence Indentification')
        self.Bind(wx.EVT_BUTTON, self.onVOpen, self.vbtn)
        
        #btn.Bind(wx.EVT_BUTTON, self.onOpen)

        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(self.my_text, 1, wx.ALL|wx.EXPAND)
        sizer.Add(self.openFileDlgBtn, 0, wx.ALL|wx.CENTER, 3)
        sizer.Add(self.btn, 0, wx.ALL|wx.CENTER, 5)
        sizer.Add(self.obtn, 0, wx.ALL|wx.CENTER, 3)
        sizer.Add(self.vbtn, 0, wx.ALL|wx.CENTER, 3)
        
        self.SetSizer(sizer)
        
    def OpenFl(self, event):
        dialog = wx.FileDialog(
            self,
            "Select input files",
            "",
            "",
            "fasta files (*.fasta) |*.fasta| All files |*.*",
            wx.FD_OPEN | wx.FD_FILE_MUST_EXIST | wx.FD_MULTIPLE)
        if (dialog.ShowModal() == wx.ID_OK):
            filelist = dialog.GetPaths()
            self.otherFunc(filelist)

    def otherFunc(self, filelist):
        #"do something here"
        filenames = filelist
        kgene=self.chooseGnBox.GetStringSelection()
        kalign=self.chooseOneBox.GetStringSelection()
        f=open("inpfl.dat", "w+")
        for fln in range(0,len(filenames)):
            inpnmbr = filenames[fln]
            f.write(inpnmbr)
            f.write("\n")
        f.close()
        if os.path.isfile("status.txt"):
            os.remove("status.txt")
        
        first = subprocess.Popen(['/bin/echo', kgene, kalign], stdout=subprocess.PIPE)
        second = subprocess.Popen(['bash', 'predict_sertp.sh', kgene, kalign], stdin=first.stdout)
        self.my_text.WriteText("******\n******\n\nThe Job is running.\n\n******\n******\n\n")
        
        while not os.path.exists("status.txt"):
            #self.my_text.WriteText("The Job is running.\n")
            time.sleep(1)
            
        if os.path.isfile("status.txt"):
            self.my_text.WriteText("The Jobs are completed. Click the buttons below for prdicted output.\n\n******\n******\n\n")
            # read file
        else:
            raise ValueError("Issue with submission. Try again\n\n******\n******\n\n")
        
    def onOpen(self, event):
        #kflnm=self.nameBox.GetValue()
        self.my_text.WriteText("Following are K-type predicted for the query inputs. Column are separated by tab.\n\n******\n******\n\n")
        path="K_PAM_predict.dat"
        if os.path.exists(path):
            with open(path) as fobj:
                for line in fobj:
                    self.my_text.WriteText(line)
        self.my_text.WriteText("******\n******\n\n")

    def onOOpen(self, event):
        #kflnm=self.nameBox.GetValue()
        self.my_text.WriteText("Following are O-type predicted for the query inputs. Column are separated by tab.\n\n******\n******\n\n")
        path="K_PAM_O_predict.dat"
        if os.path.exists(path):
            with open(path) as fobj:
                for line in fobj:
                    self.my_text.WriteText(line)
        self.my_text.WriteText("******\n******\n\n")
        
    def onVOpen(self, event):
        #kflnm=self.nameBox.GetValue()
        self.my_text.WriteText("Following are predicted virulence genes found in the query inputs.\n\n******\n******\n\n")
        path="K_PAM_vir_predict.dat"
        if os.path.exists(path):
            with open(path) as fobj:
                for line in fobj:
                    self.my_text.WriteText(line)
        self.my_text.WriteText("\n Note: rmpA/rmpA2 and iucABCD are major markers for hypervirulent strains.\n\n******\n******\n\n")
                    
    def Quit(self, e):
        self.Close()

    def popup(self, event):
        pop = NewFrame()

    def OnMove(self, e): 
      x, y = e.GetPosition() 
      print ("current window position x = ",x," y= ",y)

class MainPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        hsizer = wx.BoxSizer(wx.HORIZONTAL)
        v_sizer = wx.BoxSizer(wx.VERTICAL)

        left_panel = LeftPanel(self)
        hsizer.Add(left_panel,1,wx.EXPAND)

        self.done_btn = wx.Button(self, -1, "DONE")
        self.Bind(wx.EVT_BUTTON, self.OnDone, self.done_btn)

        v_sizer.Add(hsizer, 1, wx.EXPAND)
        v_sizer.Add(self.done_btn,0, wx.ALL |wx.CENTER, 3)

        self.SetSizer(v_sizer)
        
    def OnDone(self,event):
        self.Close()
        self.Parent.Destroy()

class KFrame(wx.Frame):
    def __init__(self):
        wx.Frame.__init__(self, None, title="Serotype Prediction & Virulence Identification", size=(800,600))
        panel = MainPanel(self)
        self.SetWindowStyle(wx.STAY_ON_TOP)
        self.Show()
