#!/bin/bash

#echo "File_name,Virulence,rmpA,rmpA2,iucA,iucB,iucC,iucD,iutA,iroB,iroC,iroD,iroN" > virulence_pred.csv

ncnmm=$1
ncnm=`echo $ncnmm | cut -d "." -f1 | rev | cut -d"/" -f1  | rev`
kppath=`echo $ncnmm | cut -d "." -f1 | rev | cut -d"/" -f2-  | rev`
kpath=$kppath"/"
    
    rm -rf newfas.fasta
    cp $ncnmm newfas.fasta
    rm -rf "resulvt_"$ncnm".txt"
    rm -rf resultvir.dat
    echo -e "Query,Target (Database sequence),% Identity,Alignment length,No. of mismatches,No. of gap opens,Start posit
ion in query,End position in query,Start position in target,End position in target,E-value,Bit-score">result.csv

    makeblastdb -in hvgn.fsa -dbtype nucl
    blastn -query newfas.fasta -db hvgn.fsa -outfmt 6 > hvlout.out
    blastn -query newfas.fasta -db hvgn.fsa -outfmt 0 > align.txt

    if [ -s "hvlout.out" ]; then
	while read -r line || [[ -n $line ]]; do
	    a=`echo $line |awk '{print $1}'`
	    b=`echo $line |awk '{print $2}'`
	    c=`echo $line |awk '{print $3}'`
	    d=`echo $line |awk '{print $4}'`
	    e=`echo $line |awk '{print $5}'`
	    f=`echo $line |awk '{print $6}'`
	    g=`echo $line |awk '{print $7}'`
	    h=`echo $line |awk '{print $8}'`
	    i=`echo $line |awk '{print $9}'`
	    j=`echo $line |awk '{print $10}'`
	    k=`echo $line |awk '{print $11}'`
	    l=`echo $line |awk '{print $12}'`
	    m=`echo $line |awk '{printf "%3i", $3}'`
	    if [ $m -ge 60 ] && [ $d -ge 200 ]; then
		p=`echo $b | cut -d "|" -f3 | cut -d ":" -f1`
		q=`echo $b | cut -d "|" -f2`
		r=`echo $p`
		echo -e "$q   - $r   - $c   - $d   - $l   - $k" >>"resulvt_"$ncnm".txt"
	    else
		continue;
	    fi
	    echo $a,$b,$c,$d,$e,$f,$g,$h,$i,$j,$k,$l>>result.csv
	    done<hvlout.out
	
	awk '{print $1}' "resulvt_"$ncnm".txt" | sort -ru > new_combine.txt
	
	for vgn in rmpA rmpA2 iucA iucB iucC iucD iutA iroB iroC iroD iroN
	do
	    grep $vgn" " "resulvt_"$ncnm".txt" | tee -a resultvir.dat $vgn.txt
	done
	
    fi

    for vgn in rmpA rmpA2 iucA iucB iucC iucD iutA iroB iroC iroD iroN
    do
	w=`cat $vgn.txt | wc -l`
	if [ $w -gt 0 ]
	then
	    declare $vgn="Yes"
	else
	    declare $vgn="No"
	fi
    done
    
    vcnf1=`grep -i "rmpA" resultvir.dat | wc -l`
    vcnf2=`grep -i "iuc" resultvir.dat | wc -l`
    vcnf3=`cat resultvir.dat | wc -l`
    
    if [ $vcnf3 -gt 0 ]
    then
	if [ $vcnf1 -gt 0 ] || [ $vcnf2 -gt 0 ]
	then
	    vrl="Hyper_Virulent"
	else
    	    vrl="Virulent"
	fi
    else
	vrl="Classical"
    fi

    echo $ncnm","$vrl","$rmpA","$rmpA2","$iucA","$iucB","$iucC","$iucD","$iutA","$iroB","$iroC","$iroD","$iroN >> virulence_pred.csv
    
    mkdir $flnm"_V_out"
    chmod 777 $flnm"_V_out"
    mv *.out $flnm"_V_out/"
    mv *.txt $flnm"_V_out/"
    mv result.csv $flnm"_V_out/"

